.textarea {
    font-family: inherit;
    font-size: inherit;
    display: inline-flex;
    flex-direction: column;
    @include marginBottom(6);

    .wrapper {
        display: inline-flex;
        align-items: center;
        border: 1px solid $color-input-border;
        border-radius: $border-radius;
        background-color: $color-input-background;
        position: relative;
        flex-grow: 1;

        &:hover:not(.wrapper--disabled):not(.wrapper--error),
        &:active:not(.wrapper--disabled):not(.wrapper--error),
        &.focus:not(.wrapper--disabled):not(.wrapper--error) {
            border-color: $color-input-focus;
        }

        &.wrapper--disabled {
            background-color: $color-input-background-disabled;

            & * {
                cursor: not-allowed;
            }
        }

        &.wrapper--readonly {
            background-color: $color-input;
        }

        textarea {
            font-family: inherit;
            font-size: inherit;
            color: $color-input-focus;
            background-color: $color-input-background;
            box-shadow: none;
            outline: none;
            border: 0 none;
            border-radius: $border-radius;
            width: 100%;
            line-height: $line-height;
            box-sizing: content-box;
            resize: vertical;

            @include padding(2, 3);

            &::placeholder {
                color: $color-input-placeholder;
            }

            &[disabled] {
                color: $color-input-disabled;
                background-color: $color-input-background-disabled;
            }

            &[readonly] {
                color: $color-input-readonly;
                background-color: $color-input-background;
            }

            //&:invalid {
            //    border: 1px solid var(--color-input__border--error);
            //}
        }
    }

    &.error {
        .wrapper {
            border: 1px solid $color-input-border-error;
        }
    }

    &.disabled {
        .wrapper {
        }
    }

    &.readonly {
        .wrapper {
        }
    }

    &.label-position {
        &.top {
            display: inline-flex;
            flex-wrap: nowrap;
            flex-direction: column;
        }

        &.left {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: row;
            justify-content: space-between;
            align-items: flex-start;
            @include marginBottom(6);
        }
    }

    .label {
        flex: 30%;
        color: $color-base;
        min-height: $line-height * 1em;
        @include padding(2, 3, 2, 0);

        .mark {
            color: $color-input-error;
            @include marginLeft(1);
        }
    }

    .error--wrapper {
        flex: 70%;
        display: flex;
        flex-direction: column;

        .error {
            font-size: $font-size-small;
            color: $color-input-error;
            @include marginLeft(3);
        }
    }
}
